Subject: Re: bug#19889: bug#22207: emacs-25 mishandles info code text on Fedora 23

From: Eli Zaretskii <[email-masked]>
Date: Fri, 06 May 2016 22:01:48 +0300

> Cc: [email-masked], [email-masked], [email-masked]
> From: Paul Eggert <[email-masked]>
> Date: Fri, 6 May 2016 11:24:14 -0700
> 
> On 05/06/2016 10:18 AM, Eli Zaretskii wrote:
> > We could specify the font explicitly.
> >
> >> >More specifically: is it the introduction of ‘fixed-pitch-serif’
> >> >that you’re objecting to, or the addition of FreeMono and Nimbus
> >> >Mono L as fonts to look for
> > The latter.  I see that as a (perhaps complicated and a bit
> > unreliable) way of specifying a font which we know we want to get as
> > result.  If so, why not specify the font explicitly?
> 
> The problem is, which font to specify explicitly? Not all platforms have 
> a font named "Courier". Mine doesn't (Fedora 23). If we knew that all 
> Emacs platforms had an appropriate font (Courier, or FreeMono, or Nimbus 
> Mono L, or whatever), we could specify that font, but I do not know of 
> any such font, nor do I know how to query arbitrary platforms for such a 
> font.

I'm aware of the issue, but I very much doubt there are too many
variants out there.  We could enumerate them all, and try one after
another, or even do it specifically for each platform.  Which is more
or less what your patch does, isn't it?

> In further testing on my Fedora 23 host I discovered another suitable 
> anti-aliased font, Courier 10 Pitch.

So why do you say above you don't have Courier?

> It is also a free font and looks a bit better with emacs -Q, and
> Wikipedia says Courier 10 Pitch BT is the default Courier font on
> many GNU/Linux hosts
> <https://en.wikipedia.org/wiki/Courier_%28typeface%29#Courier_10_Pitch_BT>.
> So I will update my proposed patch to prefer Courier 10 Pitch to the
> alternatives already in the list.

We could systematically review the most popular platforms (how many
are there, anyway?), and simply state a font or a couple of them for
each platform.  And I won't be surprised if all of them mostly use the
same fonts, even if some of them aren't necessarily present sometimes.

IOW, I prefer naming fonts rather than asking for them via families.